#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#define N 8

sem_t s[N][N];

void init()
{
    int i, j;
    for (i=0; i<N; i++) 
        for(j=0; j<N; j++) 
            sem_init(&s[i][j], 0, 0); 
}

void *thread(void *arg)
{
    int k = *((int *) arg); int j;
    printf("TH%d: before synch\n", k);
    for (j=0; j<N; j++) 
        if (j!=k) sem_post(&s[k][j]);
    for (j=0; j<N; j++) 
        if (j!=k) sem_wait(&s[j][k]);
    printf("TH%d: after synch\n", k);
    return 0;
}

int main()
{
    pthread_t tid[N];
    int i;
    int args[N];

    init();

    for (i=0; i<N; i++) {
        args[i] = i;
        pthread_create(&tid[i], 0, thread, 
                       (void *)&args[i]);
    }
    for (i=0; i<N; i++) 
        pthread_join(tid[i], 0);

    printf("Main: exiting\n");
    return 0;
}
